Index: src/org/jboss/ide/eclipse/freemarker/model/Interpolation.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/Interpolation.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/Interpolation.java	(working copy)
@@ -34,6 +34,7 @@
 import org.eclipse.jface.text.source.ISourceViewer;
 import org.jboss.ide.eclipse.freemarker.model.interpolation.BuiltInFragment;
 import org.jboss.ide.eclipse.freemarker.model.interpolation.Fragment;
+import org.jboss.ide.eclipse.freemarker.model.interpolation.IndexedParametersFragment;
 import org.jboss.ide.eclipse.freemarker.model.interpolation.NameFragment;
 import org.jboss.ide.eclipse.freemarker.model.interpolation.NullFragment;
 import org.jboss.ide.eclipse.freemarker.model.interpolation.ParametersFragment;
@@ -93,15 +94,15 @@
 			else break;
 		}
 		if (null != fragment) {
-			// find the parent class
-			Class parentClass = null;
-			for (Iterator i = fragments.iterator(); i.hasNext(); ) {
-				Fragment fragmentSub = (Fragment) i.next();
-				if (fragmentSub.equals(fragment)) break;
-				else parentClass = fragmentSub.getReturnClass(parentClass, fragments, context, getResource(), getResource().getProject());
-			}
-			return fragment.getCompletionProposals(
-				subOffset - fragment.getOffset(), offset, parentClass, fragments, getViewer(), context, getResource(), getResource().getProject());
+		    // find the parent object
+            Object parentObject = null;
+            for (Iterator i = fragments.iterator(); i.hasNext(); ) {
+                Fragment fragmentSub = (Fragment) i.next();
+                if (fragmentSub.equals(fragment)) break;
+                else parentObject = fragmentSub.getReturnObject(parentObject, fragments, context, getResource(), getResource().getProject());
+            }
+            return fragment.getCompletionProposals(
+                subOffset - fragment.getOffset(), offset, parentObject, fragments, getViewer(), context, getResource(), getResource().getProject());
 		}
 		else if (getContents().length() == 0 && subOffset == 0) {
 			return new NullFragment().getCompletionProposals(
@@ -122,13 +123,14 @@
 		boolean inBuiltIn = false;
 		boolean inNameFragment = false;
 		boolean inParameters = false;
+        boolean inIndexedParameters = false;
 		boolean escape = false;
 		boolean doEscape = false;
 		int offset = getOffset();
 		for (int i=0; i<contents.length(); i++) {
 			doEscape = false;
 			char c = contents.charAt(i);
-			if (Character.isLetterOrDigit(c) && !inString && !inBuiltIn && !inNameFragment && !inParameters)
+			if (Character.isLetterOrDigit(c) && !inString && !inBuiltIn && !inNameFragment && !inParameters && !inIndexedParameters)
 				inNameFragment = true;
 			if (inNameFragment) {
 				if (c == '?') {
@@ -159,6 +161,21 @@
 					sb.delete(0, sb.length());
 					inNameFragment = false;
 				}
+                else if (c == '[') {
+                    // for now, forget about the stack
+                    fragments.add(new NameFragment(offsetStart, sb.toString()));
+                    offsetStart = i;
+                    sb.delete(0, sb.length());
+                    inNameFragment = false;
+                    inIndexedParameters = true;
+                }
+                else if (c == ']') {
+                    // for now, forget about the stack
+                    fragments.add(new NameFragment(offsetStart, sb.toString()));
+                    offsetStart = i+1;
+                    sb.delete(0, sb.length());
+                    inNameFragment = false;
+                }
 				else sb.append(c);
 			}
 			else if (inBuiltIn) {
@@ -192,6 +209,21 @@
 				}
 				else sb.append(c);
 			}
+            else if (inIndexedParameters) {
+                if (inString) if (!escape && c == '\"') inString = false;
+                if (!inString && c == ']') {
+                    fragments.add(new IndexedParametersFragment(offsetStart, sb.toString()));
+                    offsetStart = i+1;
+                    sb.delete(0, sb.length());
+                }
+                else  {
+                    if (c == '.') { 
+                        inIndexedParameters = false;
+                        inNameFragment = true;
+                    }
+                    sb.append(c);
+                }
+            }
 			else if (inString) {
 				if (escape) sb.append(c);
 				else if (c == '\"') {
@@ -233,6 +265,18 @@
 					sb.delete(0, sb.length());
 				}
 			}
+            else if (c == '[') {
+                if (fragments.size() == 0) {
+                    // for now, forget about the stack
+                }
+                else {
+                    if (sb.length() > 0 && !inBuiltIn)
+                        fragments.add(new NameFragment(offsetStart, sb.toString()));
+                    inIndexedParameters = true;
+                    offsetStart = i;
+                    sb.delete(0, sb.length());
+                }
+            }
 			else if (c == '"') {
 				if (sb.length() > 0) fragments.add(new NameFragment(offsetStart, sb.toString()));
 				inString = true;
@@ -257,26 +301,26 @@
 		return false;
 	}
 
-	public Class getReturnClass (Map context) {
+    public Object getReturnObject (Map context) {
+        initFragments();
+        Object returnObject = null;
+        for (Iterator i=fragments.iterator(); i.hasNext(); ) {
+            Fragment fragment = (Fragment) i.next();
+            returnObject = fragment.getReturnObject(returnObject, fragments, context, getResource(), getResource().getProject());
+        }
+        return returnObject;
+    }
+    
+	public Object getSingularReturnObject (Map context) {
 		initFragments();
-		Class returnClass = null;
+		Object returnObject = null;
 		for (Iterator i=fragments.iterator(); i.hasNext(); ) {
 			Fragment fragment = (Fragment) i.next();
-			returnClass = fragment.getReturnClass(returnClass, fragments, context, getResource(), getResource().getProject());
+            if (i.hasNext())
+                returnObject = fragment.getReturnObject(returnObject, fragments, context, getResource(), getResource().getProject());
+            else
+                returnObject = fragment.getSingularReturnObject(returnObject, fragments, context, getResource(), getResource().getProject());
 		}
-		return returnClass;
-	}
-
-	public Class getSingularReturnClass (Map context) {
-		initFragments();
-		Class returnClass = null;
-		for (Iterator i=fragments.iterator(); i.hasNext(); ) {
-			Fragment fragment = (Fragment) i.next();
-			if (i.hasNext())
-				returnClass = fragment.getReturnClass(returnClass, fragments, context, getResource(), getResource().getProject());
-			else
-				returnClass = fragment.getSingularReturnClass(returnClass, fragments, context, getResource(), getResource().getProject());
-		}
-		return returnClass;
+		return returnObject;
 	}
 }
\ No newline at end of file
Index: src/org/jboss/ide/eclipse/freemarker/model/AbstractItem.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/AbstractItem.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/AbstractItem.java	(working copy)
@@ -153,6 +153,7 @@
 		boolean doAppend = true;
 		boolean encounteredSpace = false;
 		boolean nextCharSpace = false;
+        boolean encounteredEscapeVariableName = false; // true for doc["fffff
 		for (int i=0; i<s.length(); i++) {
 			encounteredSpace = false;
 			char c = s.charAt(i);
@@ -226,8 +227,33 @@
 				}
 			}
 			if (doAppend) {
-				current.append(c);
-				offsetCount++;
+                boolean doAppendSpecialCharacter = false;
+                if (c == '\"') {
+                    // current character is "
+                    // if s=doc["hibernate-mapping"]. ...
+                    // doc.hibernate-mapping. must be returned
+                    if (i > 2 && s.charAt(i-1) == '[') {
+                        char lastChar = s.charAt(i-2);
+                        if (lastChar != ' ' && lastChar != '=') {
+                            encounteredEscapeVariableName = true;
+                            doAppendSpecialCharacter = true;
+                            current.append('.');
+                            offsetCount++;
+                        }
+                    }
+                    else {
+                        if (s.length() > i + 2&& s.charAt(i+1) == ']') {
+                            char nextChar = s.charAt(i+2);
+                            if (encounteredEscapeVariableName == true)
+                                doAppendSpecialCharacter = true;
+                            encounteredEscapeVariableName = false;
+                        }
+                    }
+                }
+                if (!doAppendSpecialCharacter) {
+                    current.append(c);
+                    offsetCount++;
+                }
 			}
 			escape = doEscape;
 			doEscape = false;
Index: src/org/jboss/ide/eclipse/freemarker/model/interpolation/StringFragment.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/interpolation/StringFragment.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/interpolation/StringFragment.java	(working copy)
@@ -38,11 +38,11 @@
 		super(offset, content);
 	}
 
-	public Class getReturnClass (Class parentClass, List fragments, Map context, IResource resource, IProject project) {
-		return parentClass;
+	public Object getReturnObject (Object parentObject, List fragments, Map context, IResource resource, IProject project) {
+		return parentObject;
 	}
 
-	public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Class parentClass,
+	public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Object parentObject,
 			List fragments, ISourceViewer sourceViewer, Map context, IResource file, IProject project) {
 		return null;
 	}
Index: src/org/jboss/ide/eclipse/freemarker/model/interpolation/Fragment.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/interpolation/Fragment.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/interpolation/Fragment.java	(working copy)
@@ -34,10 +34,10 @@
  */
 public interface Fragment {
 
-	public int getOffset();
-	public int getLength();
-	public Class getReturnClass (Class parentClass, List fragments, Map context, IResource resource, IProject project);
-	public Class getSingularReturnClass (Class parentClass, List fragments, Map context, IResource resource, IProject project);
-	public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Class parentClass,
-			List fragments, ISourceViewer sourceViewer, Map context, IResource file, IProject project);
+    public int getOffset();
+    public int getLength();
+    public Object getReturnObject (Object parentObject, List fragments, Map context, IResource resource, IProject project);
+    public Object getSingularReturnObject (Object parentObject, List fragments, Map context, IResource resource, IProject project);
+    public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Object parentObject,
+            List fragments, ISourceViewer sourceViewer, Map context, IResource file, IProject project);
 }
Index: src/org/jboss/ide/eclipse/freemarker/model/interpolation/IndexedParametersFragment.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/interpolation/IndexedParametersFragment.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/model/interpolation/IndexedParametersFragment.java	(revision 0)
@@ -0,0 +1,42 @@
+package org.jboss.ide.eclipse.freemarker.model.interpolation;
+
+import java.util.List;
+import java.util.Map;
+
+import org.eclipse.core.resources.IProject;
+import org.eclipse.core.resources.IResource;
+
+/**
+ *  
+ * @version 1.0.4 
+ * @author <a href="mailto:angelo.zerr@gmail.com">Angelo ZERR</a>
+ *
+ */
+public class IndexedParametersFragment extends NameFragment {
+
+	public IndexedParametersFragment(int offset, String content) {
+		super(offset, content);
+	}
+
+	public Object getReturnObject (Object parentObject, List fragments, Map context, IResource resource, IProject project) {
+		return super.getReturnObject(parentObject, fragments, context, resource, project);
+	}
+
+	public String getContent() {
+		String content = super.getContent();
+		if (content.startsWith("\""))
+			content = content.substring(1, content.length());
+		if (content.endsWith("\""))
+			content = content.substring(0, content.length() -1);
+		return content;
+	}
+	
+	public boolean isStartFragment () {
+		return false;
+	}
+	
+	public int getLength() {
+		return  getContent().length();
+	}
+	
+}
Index: src/org/jboss/ide/eclipse/freemarker/model/interpolation/NameFragment.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/interpolation/NameFragment.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/interpolation/NameFragment.java	(working copy)
@@ -42,7 +42,9 @@
 import org.eclipse.jface.text.contentassist.ICompletionProposal;
 import org.eclipse.jface.text.source.ISourceViewer;
 import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
-import org.jboss.ide.eclipse.freemarker.configuration.ContextValue;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IContextValue;
+import org.jboss.ide.eclipse.freemarker.helper.CompletionProposalHelper;
+import org.jboss.ide.eclipse.freemarker.helper.ContextValueHelper;
 
 /**
  * @author <a href="mailto:joe@binamics.com">Joe Hudson</a>
@@ -53,97 +55,149 @@
 		super(offset, content);
 	}
 
-	public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Class parentClass,
+	public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Object parentObject,
 			List fragments, ISourceViewer sourceViewer, Map context, IResource file, IProject project) {
-		if (isStartFragment()) {
-			// pull from context
-			String prefix = getContent().substring(0, subOffset);
-			List proposals = new ArrayList();
-			for (Iterator i=context.keySet().iterator(); i.hasNext(); ) {
-				String key = (String) i.next();
-				if (key.startsWith(prefix)) proposals.add(getCompletionProposal(
-						offset, subOffset, key, getContent()));
-			}
-			return completionProposals(proposals);
-		}
-		else {
-			if (null == parentClass) return null;
-			return getMethodCompletionProposals (subOffset, offset, parentClass, file);
-		}
+        String content = getContent();
+        if (ContextValueHelper.isStartFragment(content)) {
+            // pull from context
+            String prefix = getContent().substring(0, subOffset);
+            List proposals = new ArrayList();
+            for (Iterator i=context.keySet().iterator(); i.hasNext(); ) {
+                String key = (String) i.next();
+                if (key.startsWith(prefix)) proposals.add(getCompletionProposal(
+                        offset, subOffset, key, content));
+            }
+            return CompletionProposalHelper.completionProposals(proposals);
+        }
+        else {
+            if (null == parentObject) return null;
+            return CompletionProposalHelper.
+                getProposalsForParentObject(content, subOffset, offset, parentObject, file);
+        }
 	}
 
-	private Class returnClass;
-	public Class getReturnClass (Class parentClass, List fragments, Map context, IResource resource, IProject project){
-		if (null == returnClass) {
+    private Object returnObject;
+    public Object getReturnObject (Object parentObject, List fragments, Map context, IResource resource, IProject project){
+        if (null == returnObject) {
 			String content = getContent();
-			if (isStartFragment()) {
-				returnClass = (Class) context.get(content);
-			}
-			else {
-				if (null == parentClass) {
-					returnClass = Object.class;
-				}
-				else {
-					content = Character.toUpperCase(content.charAt(1)) + content.substring(2, getContent().length());
-					String getcontent = "get" + content; //$NON-NLS-1$
-					for (int i=0; i<parentClass.getMethods().length; i++) {
-						Method m = parentClass.getMethods()[i];
-						if (m.getName().equals(content) || m.getName().equals(getcontent)) {
-							returnClass = m.getReturnType();
-							break;
-						}
-					}
-				}
-			}
-		}
-		return returnClass;
-	}
+            // Test type of context 
+            Object objectContext = context.get(content);
+            if (ContextValueHelper.isStringContextValue(objectContext)) {
+                // It's String context
+                // Completion must be stopped.
+                return null;
+            }
+            
+            if (objectContext != null && 
+                ContextValueHelper.isStartFragment(content)) {
+                return objectContext;
+            }
+            
+            if ((ContextValueHelper.isXMLContextValue(objectContext) ||
+                 ContextValueHelper.isXMLContextValue(parentObject))) {
+                // It's XML context
+                String eltcontent = content; 
+                if (content.startsWith("."))
+                    eltcontent = content.substring(1, content.length());
+                return ContextValueHelper.getChildNode(parentObject, eltcontent);
+            }            
 
-	private Class singulaReturnClass;
-	public Class getSingularReturnClass(Class parentClass, List fragments, Map context, IResource resource, IProject project) {
-		if (null == singulaReturnClass) {
-			String content = getContent();
-			if (isStartFragment()) {
-				ContextValue contextValue = ConfigurationManager.getInstance(project).getContextValue(content, resource, true);
-				if (null == contextValue || null == contextValue.singularClass)
-					singulaReturnClass = Object.class;
-				else
-					singulaReturnClass = contextValue.singularClass;
-			}
-			else {
-				if (null == parentClass) {
-					singulaReturnClass = Object.class;
-				}
-				else {
-					content = Character.toUpperCase(content.charAt(1)) + content.substring(2, getContent().length());
-					String getcontent = "get" + content; //$NON-NLS-1$
-					for (int i=0; i<parentClass.getMethods().length; i++) {
-						Method m = parentClass.getMethods()[i];
-						if (m.getName().equals(content) || m.getName().equals(getcontent)) {
-							Type type = m.getGenericReturnType();
-							if (type instanceof ParameterizedType) {
-								ParameterizedType pType = (ParameterizedType) type;
-								if (pType.getActualTypeArguments().length > 0) {
-									singulaReturnClass = (Class) pType.getActualTypeArguments()[0];
-									break;
-								}
-							}
-							singulaReturnClass = Object.class;
-							break;
-						}
-					}
-				}
-			}
+           /* if ((ContextValueHelper.isDTDContextValue(objectContext) ||
+                 ContextValueHelper.isDTDContextValue(parentObject))) {
+                // It's DTD context
+                String eltcontent = content; 
+                if (content.startsWith("."))
+                    eltcontent = content.substring(1, content.length());
+                return ContextValueHelper.getChildDTDElement(parentObject, eltcontent);
+            }*/  
+            if ((ContextValueHelper.isClassContextValue(parentObject))) {
+                Class parentClass = (Class)parentObject;
+                content = Character.toUpperCase(content.charAt(1)) + content.substring(2, getContent().length());
+                String getcontent = "get" + content;
+                for (int i=0; i<parentClass.getMethods().length; i++) {
+                    Method m = parentClass.getMethods()[i];
+                    if (m.getName().equals(content) || m.getName().equals(getcontent)) {
+                        return m.getReturnType();
+                    }
+                }
+            }
+            if (null == parentObject) {
+                return Object.class;
+            }
 		}
-		return singulaReturnClass;
+		return returnObject;
 	}
 
-	public boolean isStartFragment () {
-		return !getContent().startsWith("."); //$NON-NLS-1$
+    private Object singulaReturnObject;
+    public Object getSingularReturnObject(Object parentObject, List fragments, Map context, IResource resource, IProject project) {
+        if (null == singulaReturnObject) {
+            String content = getContent(); 
+            if (ContextValueHelper.isStartFragment(content)) {
+                IContextValue contextValue = ConfigurationManager.getInstance(project).getContextValue(content, resource, true);
+                if (contextValue != null) {
+                    int contexType = contextValue.getType();
+                    if(contexType == IContextValue.CLASS) {
+                        Class singularClass = null;
+                        if (contextValue != null) 
+                            singularClass = (Class)contextValue.getSecondObjectContext().getObject();
+                        
+                        if (singularClass == null)
+                            singulaReturnObject = Object.class;
+                        else
+                            singulaReturnObject = singularClass;
+                    }
+                }
+            }
+            else {
+                if (parentObject != null) {
+                    if (ContextValueHelper.isXMLContextValue(parentObject)) {
+                        // Its' XML context
+                        String eltcontent = content; //.substring(1, content.length());
+                        if (content.startsWith("."))
+                            eltcontent = content.substring(1, content.length());
+                        return ContextValueHelper.getChildNode(parentObject, eltcontent);
+                    }
+                    else {
+                       /* if ((ContextValueHelper.isDTDContextValue(parentObject) ||
+                             ContextValueHelper.isDTDContextValue(parentObject))) {
+                            // It's DTD context
+                            String eltcontent = content; 
+                            if (content.startsWith("."))
+                                eltcontent = content.substring(1, content.length());
+                            return ContextValueHelper.getChildDTDElement(parentObject, eltcontent);
+                         } 
+                        */
+                        
+                        if (ContextValueHelper.isClassContextValue(parentObject)) {
+                            Class parentClass = (Class)parentObject;
+                            if (content.length() > 2) {
+                                content = Character.toUpperCase(content.charAt(1)) + content.substring(2, getContent().length());
+                                String getcontent = "get" + content;
+                                for (int i=0; i<parentClass.getMethods().length; i++) {
+                                    Method m = parentClass.getMethods()[i];
+                                    if (m.getName().equals(content) || m.getName().equals(getcontent)) {
+                                        Type type = m.getGenericReturnType();
+                                        if (type instanceof ParameterizedType) {
+                                            ParameterizedType pType = (ParameterizedType) type;
+                                            if (pType.getActualTypeArguments().length > 0) {
+                                                singulaReturnObject = (Class) pType.getActualTypeArguments()[0];
+                                                break;
+                                            }
+                                        }
+                                        return Object.class;
+                                    }
+                                }
+                            }
+                        }
+                    }
+                }
+            }
+        }
+        return singulaReturnObject;
 	}
 
-	public static final String[] invalidMethods = {
-		"clone", "equals", "finalize", "getClass", "hashCode", "notify", "notifyAll", "toString", "wait"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$
+    public static final String[] invalidMethods = {
+		"clone", "equals", "finalize", "getClass", "hashCode", "notify", "notifyAll", "toString", "wait"};
 	public ICompletionProposal[] getMethodCompletionProposals (int subOffset, int offset, Class parentClass, IResource file) {
 		if (instanceOf(parentClass, String.class)
 				|| instanceOf(parentClass, Number.class)
Index: src/org/jboss/ide/eclipse/freemarker/model/interpolation/BuiltInFragment.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/interpolation/BuiltInFragment.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/interpolation/BuiltInFragment.java	(working copy)
@@ -164,7 +164,7 @@
 	}
 
 	private String subContent = null;
-	public Class getReturnClass (Class parentClass, List fragments, Map context, IResource resource, IProject project) {
+    public Object getReturnObject (Object parentObject, List fragments, Map context, IResource resource, IProject project) {
 		if (null == subContent) {
 			subContent = getContent();
 			int index = subContent.indexOf("("); //$NON-NLS-1$
@@ -182,24 +182,28 @@
 		else return null;
 	}
 
-	public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Class parentClass,
+	public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Object parentObject,
 			List fragments, ISourceViewer sourceViewer, Map context, IResource file, IProject project) {
-		if (instanceOf(parentClass, String.class)) {
-			return getCompletionProposals(subOffset, offset, STRING_BUILT_INS);
-		}
-		else if (instanceOf(parentClass, Number.class)) {
-			return getCompletionProposals(subOffset, offset, NUMBER_BUILT_INS);
-		}
-		else if (instanceOf(parentClass, Date.class)) {
-			return getCompletionProposals(subOffset, offset, DATE_BUILT_INS);
-		}
-		else if (instanceOf(parentClass, Collection.class) || instanceOf(parentClass, List.class)) {
-			return getCompletionProposals(subOffset, offset, LIST_BUILT_INS);
-		}
-		else if (instanceOf(parentClass, Map.class)) {
-			return getCompletionProposals(subOffset, offset, MAP_BUILT_INS);
-		}
-		else return getCompletionProposals(subOffset, offset, OBJECT_BUILT_INS);
+        if (parentObject instanceof Class) {
+            Class parentClass = (Class)parentObject;
+            if (instanceOf(parentClass, String.class)) {
+                return getCompletionProposals(subOffset, offset, STRING_BUILT_INS);
+            }
+            else if (instanceOf(parentClass, Number.class)) {
+                return getCompletionProposals(subOffset, offset, NUMBER_BUILT_INS);
+            }
+            else if (instanceOf(parentClass, Date.class)) {
+                return getCompletionProposals(subOffset, offset, DATE_BUILT_INS);
+            }
+            else if (instanceOf(parentClass, Collection.class) || 
+                    instanceOf(parentClass, List.class)) {
+                return getCompletionProposals(subOffset, offset, LIST_BUILT_INS);
+            }
+            else if (instanceOf(parentClass, Map.class)) {
+                return getCompletionProposals(subOffset, offset, MAP_BUILT_INS);
+            }
+        }  
+        return getCompletionProposals(subOffset, offset, OBJECT_BUILT_INS);
 	}
 
 	private ICompletionProposal[] getCompletionProposals(int subOffset, int offset, Map values) {
Index: src/org/jboss/ide/eclipse/freemarker/model/interpolation/AbstractFragment.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/interpolation/AbstractFragment.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/interpolation/AbstractFragment.java	(working copy)
@@ -30,6 +30,7 @@
 import org.eclipse.core.resources.IResource;
 import org.eclipse.jface.text.contentassist.CompletionProposal;
 import org.eclipse.jface.text.contentassist.ICompletionProposal;
+import org.jboss.ide.eclipse.freemarker.helper.ClassHelper;
 
 /**
  * @author <a href="mailto:joe@binamics.com">Joe Hudson</a>
@@ -70,15 +71,7 @@
 	}
 
 	protected boolean instanceOf (Class test, Class base) {
-		if (null == test || null == base) return false;
-		while (null != test) {
-			for (int i=0; i<test.getInterfaces().length; i++) {
-				if (test.getInterfaces()[i].getClass().getName().equals(base.getName())) return true;
-			}
-			if (test.getName().equals(base.getName())) return true;
-			test = test.getSuperclass();
-		}
-		return false;
+		return ClassHelper.instanceOf(test, base);
 	}
 
 	public class CompletionProposalComparator implements Comparator {
@@ -87,7 +80,7 @@
 		}
 	}
 
-	public Class getSingularReturnClass(Class parentClass, List fragments, Map context, IResource resource, IProject project) {
-		return Object.class;
-	}
+    public Object getSingularReturnObject(Object parentObject, List fragments, Map context, IResource resource, IProject project) {
+        return null;
+    }
 }
\ No newline at end of file
Index: src/org/jboss/ide/eclipse/freemarker/model/interpolation/ParametersFragment.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/interpolation/ParametersFragment.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/interpolation/ParametersFragment.java	(working copy)
@@ -34,16 +34,16 @@
  */
 public class ParametersFragment extends AbstractFragment {
 
-	public ParametersFragment(int offset, String content) {
-		super(offset, content);
-	}
+    public ParametersFragment(int offset, String content) {
+        super(offset, content);
+    }
 
-	public Class getReturnClass (Class parentClass, List fragments, Map context, IResource resource, IProject project) {
-		return parentClass;
-	}
+    public Object getReturnObject (Object parentObject, List fragments, Map context, IResource resource, IProject project) {
+        return parentObject;
+    }
 
-	public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Class parentClass,
-			List fragments, ISourceViewer sourceViewer, Map context, IResource file, IProject project) {
-		return null;
-	}
+    public ICompletionProposal[] getCompletionProposals (int subOffset, int offset, Object parentClass,
+            List fragments, ISourceViewer sourceViewer, Map context, IResource file, IProject project) {
+        return null;
+    }
 }
